package com.huimv.env.admin.controller;



import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.env.common.entity.BasePigpen;
import com.huimv.env.common.mapper.BasePigpenMapper;
import com.huimv.env.common.service.IBasePigpenService;
import com.huimv.env.common.utils.Result;
import com.huimv.env.common.utils.ResultUtil;
import com.huimv.env.common.entity.dto.BasePigpenDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-02-13
 */
@RestController
@RequestMapping("/basePigpen")
@CrossOrigin
public class BasePigpenController {
    @Autowired
    private IBasePigpenService basePigpenService;
    @Autowired
    private BasePigpenMapper basePigpenMapper;

    @PostMapping( "/addPigpen")
    public Result addPigpen(@RequestBody BasePigpenDto basePigpenDto) {
        return basePigpenService.addPigpen(basePigpenDto);
    }

    @PostMapping( "/addUnit")
    public Result addUnit(@RequestBody Map<String,String> map) {
        String farmId = map.get("farmId");
        String parentId = map.get("parentId");
        int buildNum = Integer.valueOf(map.get("buildNum"));
        String stageCode = map.get("stageCode");
        BasePigpen parent = basePigpenService.getById(parentId);
        String parentIds = parent.getOther2() + "," + parentId;

         int   maxBuildNum = basePigpenMapper.getMaxBuildNum(parentId);

        List<BasePigpen> basePigpenList = new ArrayList<>();
        for (int i = 1; i <= buildNum; i++) {
            int num = maxBuildNum+i;
            BasePigpen basePigpen = new BasePigpen();
            basePigpen.setBuildName(parent.getBuildName()+num+"单元");
            basePigpen.setParentId(Integer.valueOf(parentId));
            basePigpen.setFType(3);
            basePigpen.setStageCode(Integer.valueOf(stageCode));
            basePigpen.setFarmId(Integer.valueOf(farmId));
            basePigpen.setOther1(String.valueOf(num));
            basePigpen.setOther2(parentIds);
            basePigpenList.add(basePigpen);
        }

        if ( basePigpenService.saveBatch(basePigpenList)){
            return ResultUtil.addResult(1);
        }
        return ResultUtil.addResult(0);
    }

    @PostMapping( "/updatePigpen")
    public Result updatePigpen(@RequestBody BasePigpen basePigpen) {
         return  basePigpenService.updatePigpen(basePigpen);
    }

    @PostMapping( "/updateUnit")
    public Result updateUnit(@RequestBody BasePigpen basePigpen) {
        if ( basePigpenService.updateById(basePigpen)){
            return ResultUtil.addResult(1);
        }
        return ResultUtil.addResult(0);
    }

    @PostMapping( "/deletePigpen")
    public Result deletePigpen(@RequestBody Map<String,Integer> map) {
        return  basePigpenService.deletePigpen(map);
    }

    @RequestMapping(value = "/list",method = RequestMethod.POST)
    public Result list(@RequestBody Map<String, Object> paramsMap) {
        System.out.println("paramsMap>>"+paramsMap.toString());
        String farmCode = "";
        if (paramsMap.get("farmId") != null) {
            farmCode = paramsMap.get("farmId")+"";
        }
        String stageCode = "";
        if (paramsMap.get("stageCode") != null) {
            stageCode = paramsMap.get("stageCode")+"";
        }
        String buildName = "";
        if (paramsMap.get("buildName") != null) {
            buildName = paramsMap.get("buildName")+"";
        }
        return basePigpenService.list(farmCode,buildName,stageCode);
    }

    @PostMapping( "/addTest")
    public void addTest(@RequestBody Map<String,String> map) {
        String farmId = map.get("farmId");
        BasePigpen id = basePigpenService.getOne(new QueryWrapper<BasePigpen>().eq("farm_id",farmId).orderByDesc("id").last(" limit 1"));
        String count = map.get("count");
        for (int i = 0; i < Integer.parseInt(count); i++) {
            BasePigpen basePigpen = new BasePigpen();
            basePigpen.setParentId(id.getParentId());
            basePigpen.setFarmId(id.getFarmId());
            basePigpen.setFType(id.getFType());
            basePigpen.setSort(id.getSort());
            basePigpen.setStageCode(id.getStageCode());
            basePigpen.setOther2(id.getOther2());
            basePigpen.setBuildName(String.valueOf(i+2));
            basePigpenService.save(basePigpen);
        }
    }
}
