package com.huimv.env.admin.controller;



import com.huimv.env.common.entity.EnergyEnvDevice;
import com.huimv.env.common.service.IEnergyEnvDeviceService;
import com.huimv.env.common.utils.PdfUtil;
import com.huimv.env.common.utils.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-02-21
 */
@CrossOrigin
@RestController
@RequestMapping("/admin/energyEnvDevice")
public class EnergyEnvDeviceController {
    @Autowired
    private IEnergyEnvDeviceService energyEnvDeviceService;

    @RequestMapping("/DeviceList")
    public Result getDeviceList(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return energyEnvDeviceService.list(httpServletRequest,paramsMap);
    }

    @RequestMapping("/DeviceAdd")
    public Result getDeviceAdd(HttpServletRequest httpServletRequest, @RequestBody EnergyEnvDevice energyEnvDevice) {
        return energyEnvDeviceService.add(httpServletRequest,energyEnvDevice);
    }

    @RequestMapping("/DeviceEdit")
    public Result getDeviceEdit(HttpServletRequest httpServletRequest, @RequestBody EnergyEnvDevice energyEnvDevice) {
        return energyEnvDeviceService.edit(httpServletRequest,energyEnvDevice);
    }

    @RequestMapping("/DeviceDelete")
    public Result getDeviceDelete(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return energyEnvDeviceService.delete(httpServletRequest,paramsMap);
    }
    @RequestMapping("/deviceCount")
    public Result  deviceCount(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return energyEnvDeviceService.deviceCount(httpServletRequest,paramsMap);
    }

    @PostMapping("/importData")
    public Result importData(HttpServletRequest httpServletRequest, @RequestParam(name = "file") MultipartFile file,
                             @RequestParam(name = "farmId") String farmId,
                             @RequestParam(name = "unitId") String unitId,
                             @RequestParam(name = "farmName") String farmName) throws Exception {
        Map<String, String> map = new HashMap<>();
        map.put("farmId", farmId);
        map.put("unitId", unitId);
        map.put("farmName", farmName);
        return energyEnvDeviceService.importData(httpServletRequest, map, file);
    }
    @PostMapping("/updateName")
    public Result updateName(HttpServletRequest httpServletRequest, @RequestParam(name = "file") MultipartFile file) throws Exception {
        return energyEnvDeviceService.updateName(httpServletRequest, file);
    }
    @RequestMapping("/bandingUnitId")
    public Result bandingUnitId(HttpServletRequest httpServletRequest, @RequestBody EnergyEnvDevice envDevice) {
        return energyEnvDeviceService.bandingUnitId(httpServletRequest,envDevice);
    }
    @RequestMapping("/unBandingUnitId")
    public Result unBandingUnitId(HttpServletRequest httpServletRequest, @RequestBody EnergyEnvDevice envDevice) {
        envDevice.setUnitId(0);
        envDevice.setUnitName("");
        energyEnvDeviceService.updateById(envDevice);
        return new Result(10000,"解绑成功",true);
    }

    @GetMapping("/printData")
    public void printChi(HttpServletResponse response) throws Exception {
        energyEnvDeviceService.getData();
        String path = "G://getData.xls";
        PdfUtil.returnPdfStream3(response, path, "电表列表");
    }

    @GetMapping("/printDeviceList")
    public void printDeviceList(HttpServletResponse response,@RequestParam("farmId") String farmId) throws Exception {
        energyEnvDeviceService.getDeviceList(farmId);
        String path = "G://getDeviceList.xls";
        PdfUtil.returnPdfStream3(response, path, "水电表设备列表");
    }
    @RequestMapping("/updateStart")
    public Result updateStart(@RequestBody Map<String, String> paramsMap) {
        return energyEnvDeviceService.updateStart(paramsMap);
    }
}
