package com.huimv.env.input.server;

import cn.hutool.core.util.ObjectUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.env.common.entity.JinghongWater;
import com.huimv.env.common.service.IJinghongWaterService;
import com.huimv.env.common.utils.RegexUtil;
import com.huimv.env.input.producer.Producer;
//import com.huimv.env.input.service.ICommandProcessorService;
import com.huimv.env.input.utils.DateUtil2;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;

import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;
import io.netty.util.CharsetUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import java.io.IOException;
import java.nio.charset.Charset;
import java.text.ParseException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@ChannelHandler.Sharable
@Component
@Slf4j
public class EnvInputServerHandler extends ChannelInboundHandlerAdapter {
    @Autowired
    private RegexUtil regexUtil;
//    @Autowired
//    private ICommandProcessorService cmdProService;
    @Autowired
    private DateUtil2 dateUtil;
//    @Autowired
//    private IRawDataService rawDataService;
    @Autowired
    private Producer producer;
    private StringBuilder askTextSb = null;

    //
    public void appendClientAsk(String text) {
        if (this.askTextSb == null) {
            askTextSb = new StringBuilder();
        }
        askTextSb.append(text);
    }

    @Override
    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
        ByteBuf data = (ByteBuf) msg;
        String clientAskText = data.toString(CharsetUtil.UTF_8);
        //保存实例内的客户端请求
        appendClientAsk(clientAskText);
        //临时写入耳标数据到文件
//        writeTxt(clientAskText,"all");
    }

    @Override
    public void channelReadComplete(ChannelHandlerContext ctx) throws Exception {
//        if (askTextSb.toString().indexOf("end") != -1) {
            // {处理客户端消息}
            handleClientAskCmd(askTextSb.toString(), ctx);
            //清空重置;
            askTextSb.delete(0, askTextSb.length());
//        }
    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        if (cause.getMessage().indexOf("Connection reset") != -1) {
            log.info("相关采集器设备正在重启:" + cause.toString());
        }
//        cause.printStackTrace();
        ctx.close();
    }

    /**
     * @Method : handleClientAskCmd
     * @Description : 处理请求小心
     * @Params : [clientAskText, ctx]
     * @Return : void
     * @Author : ZhuoNing
     * @Date : 2022/3/28
     * @Time : 17:36
     */
    @Autowired
    private IJinghongWaterService jinghongWaterService;

    private void handleClientAskCmd(String clientAskText, ChannelHandlerContext ctx) throws ParseException, IOException {

        System.out.println("接收到消息: " + clientAskText + "  时间: " + System.currentTimeMillis());

            // 假设clientAskText是一个十六进制编码的字符串，需要转换为ByteBuf
        if (clientAskText.length() == 15){
            JinghongWater jinghongWater = new JinghongWater();
            jinghongWater.setCreateTime(new Date());
            jinghongWater.setDeviceId(clientAskText);
            jinghongWater.setDeviceName(getDevice(clientAskText));
            jinghongWaterService.save(jinghongWater);
            ByteBuf bufff = Unpooled.buffer();
            if ("861213058846640".equals(clientAskText)){
                bufff.writeBytes(hexString2Bytes("01030004000285CA"));
                ctx.writeAndFlush(bufff);
            }else {
                bufff.writeBytes(hexString2Bytes("010410180002F50C"));
                ctx.writeAndFlush(bufff);
            }

        }else {
            JinghongWater id = jinghongWaterService.getOne(new QueryWrapper<JinghongWater>().orderByDesc("id").last("limit 1"));

            // 获取GBK字符集
            Charset gbkCharset = Charset.forName("GBK");
            // 将字符串转换为GBK编码的字节数组
            byte[] gbkBytes = (clientAskText).getBytes(gbkCharset);
            System.out.println("22222"  );
            // 打印GBK编码的字节数组（以十六进制格式展示）
            String raw = bytesToHex(gbkBytes);
            System.out.println("GBK编码的字节数组（十六进制）: " + raw);
            id.setRaw(raw);
            //0104040000243f213c
            if(raw.startsWith("010304")){
                id.setValueA(getFloat(raw.substring(6, 14)));
            }else {
                int i = Integer.parseInt(raw.substring(6, 14), 16);
                id.setValueA(i+"");
            }
            jinghongWaterService.updateById(id);
            ctx.writeAndFlush("");
        }

//        askTextSb.delete(0, askTextSb.length());
        //        if (clientAskText.length() > 10) {
//            HashMap<String, String> paramsMap = new HashMap<>();
//            JSONObject jsonObject = new JSONObject();
//            jsonObject.put("result", clientAskText);
//            System.out.println(jsonObject);
//            paramsMap.put("Content-Type", "application/json;charset=utf-8");
//            String post = HttpRequest.post("https://huatong.ifarmcloud.com/huatongApi/env-nh3-n/send")
//                    .headerMap(paramsMap, false).body(jsonObject.toJSONString()).timeout(30 * 1000).execute().body();
//            System.out.println(post);
//        }



//        clientAskText = clientAskText.replaceAll("\r", "").replaceAll("\n", "");
////        {处理非正常命令}
//        int countPlus = regexUtil.countPlus(clientAskText);
//        if (countPlus < 4) {
//            System.out.println("当前数据为不完整数据，故丢弃.>>" + clientAskText);
//        } else {
////        --处理客户端请求数据
////        {拆分粘包数据}
//        JSONArray askJa = parseAskCmdPackage(clientAskText);
//        for (int a = 0; a < askJa.size(); a++) {
//            String askText = askJa.getString(a);
//            //{处理请求命令}
//            askCmdActuator(askText, ctx);
//        }
//        }
    }

    private   String  getFloat(String hexString ) {


        byte[] bytes = new byte[4];
        for (int i = 0; i < 4; i++) {
            // 每两个字符表示一个字节
            String byteString = hexString.substring(i * 2, (i + 1) * 2);
            // 将16进制字符串转换为整数，并强制转换为byte
            bytes[i] = (byte) Integer.parseInt(byteString, 16);
        }

        // 使用ByteBuffer（或者你可以直接操作字节数组）
        // 但由于我们只需要一个int来表示float，所以这里直接组合字节为int
        int intValue = ((bytes[0] & 0xFF) << 24) |
                ((bytes[1] & 0xFF) << 16) |
                ((bytes[2] & 0xFF) << 8)  |
                (bytes[3] & 0xFF);

        // 将int值转换为float值
        float floatValue = Float.intBitsToFloat(intValue);
        return floatValue+"";
        // 输出结果
    }

    public String getDevice(String deviceId){
        switch (deviceId){
            case "861213058846764":
                return "庙贝";
            case "861213058872158":
                return "芙江";
            case "861213058861409":
                return "污水电磁流量计";
            case "861213058829596":
                return "凤行";
            case "861213058846640":
                return "凤行2";
        }
        return null;
    }

    private static String bytesToHex(byte[] bytes) {
        StringBuilder sb = new StringBuilder();
        for (byte b : bytes) {
            sb.append(String.format("%02x", b));
        }
        return sb.toString();
    }
    public static String bytes2HexString(byte[] b) {
        String r = "";
        for (int i = 0; i < b.length; i++) {
            String hex = Integer.toHexString(b[i] & 0xFF);
            if (hex.length() == 1) {
                hex = '0' + hex;
            }
            r += hex.toUpperCase() + " ";
        }
        return r;
    }
    public static byte[] hexString2Bytes(String src) {

        int l = src.length() / 2;

        byte[] ret = new byte[l];

        for (int i = 0; i < l; i++) {

            ret[i] = (byte) Integer.valueOf(src.substring(i * 2, i * 2 + 2), 16).byteValue();

        }

        return ret;

    }
    /**
     * @Method : askCmdActuator
     * @Description :
     * @Params : [askText, ctx]
     * @Return : void
     * @Author : ZhuoNing
     * @Date : 2022/3/23
     * @Time : 18:08
     */
    private void askCmdActuator(String askText, ChannelHandlerContext ctx) throws ParseException, IOException {
        System.out.println("======>接收设备请求:" + askText);
        String[] dataArray = askText.split("\\+");
        String cmdHeader = dataArray[0];
        if (!cmdHeader.trim().equalsIgnoreCase("hm")) {
            log.info("当前命令是非hm命令[" + askText + "]");
            return;
        }
        //芯片id/设备编码
        String idCode = dataArray[1];
        String cmd = dataArray[2];
        Map map = new HashMap();
        map.put("askText", askText);
//        rawDataService.insert(idCode,askText);
        switch (cmd) {
//            case "1":
//                //获取远程设备编码
//                getDeviceCode(askText, idCode, ctx);
//                break;
//            case "2":
//                //同步时间
//                getServerTime(askText, idCode, ctx);
//                break;
//            case "3":
//                //日龄上传
//                uploadDayAge(askText, idCode, ctx);
//                break;
//            case "4":
//                //通风等级
//                uploadFeng(askText, idCode, ctx);
//                break;
//            case "5":
//                //室外温度
//                uploadOutTemp(askText, idCode, ctx);
//                break;
//            case "6":
//                //室内温度 平均温度
//                uploadInTemp(askText, idCode, ctx);
//                break;
//            case "7":
//                //目标温度
//                uploadTargetnTemp(askText, idCode, ctx);
//                break;
//            case "8":
//                //水暖温度
//                uploadShuiNuanTemp(askText, idCode, ctx);
//                break;
//            case "9":
//                //水暖温度
//                uploadWeiZhiTemp(askText, idCode, ctx);
//                break;
//            case "21":
//                //温度
//                uploadTemp(askText, idCode, ctx);
//                break;
//            case "22":
//                //湿度
//                uploadHumi(askText, idCode, ctx);
//                break;
//            case "23":
//                //co2
//                uploadCo2(dataArray,askText, idCode, ctx);
//                break;
//            case "24":
//                //压力
//                uploadYaLi(dataArray,askText, idCode, ctx);
//                break;
//            case "31":
//                //水表
//                uploadShuiBiao(dataArray,askText, idCode, ctx);
//                break;
//            case "32":
//                //电表
//                uploadDianBiao(dataArray,askText, idCode, ctx);
//                break;
//            case "41":
//                //报警
//                uploadWarning(askText, idCode, ctx);
//                break;
//            case "42":
//                //报警
//                uploadStatusWaraning(askText, idCode, ctx);
//                break;
//            case "61":
//                //风机状态
//                uploadFengStatus(askText, idCode, ctx);
//                break;
//            case "62":
//                //湿帘状态
//                uploadShiLianStatus(askText, idCode, ctx);
//                break;
//            case "63":
//                //喷雾状态
//                uploadPengWuStatus(askText, idCode, ctx);
//                break;
//            case "64":
//                //加热器状态
//                uploadJiaReQiStatus(askText, idCode, ctx);
//                break;
//            case "65":
//                //小窗状态
//                uploadXiaoChuangStatus(askText, idCode, ctx);
//                break;
//            case "66":
//                //导流板状态
//                uploadDaoLiuBanStatus(askText, idCode, ctx);
//                break;
//            case "67":
//                //照明状态
//                uploadZhaoMingStatus(askText, idCode, ctx);
//                break;
//            case "81":
//                //日龄配置
//                uploadDayAgePeizhiuStatus(askText, idCode, ctx);
//                break;
//            case "82":
//                //通风级别配置
//                uploadTongFengPeizhiuStatus(askText, idCode, ctx);
//                break;
//            case "91":
//                //通获取日龄配置
//                uploadGainDayAgePeizhiuStatus(dataArray,askText, idCode, ctx);
//                break;
//            case "92":
//                //通风级别配置
//                uploadGainTongFengPeizhiuStatus(dataArray,askText, idCode, ctx);
//                break;
//            default:
//                System.out.println("==>未知命令");
//                log.error(">>当前数据为非法数据-未知命令>>" + askText);
        }
    }
//
//    private void uploadZhaoMingStatus(String askText, String idCode, ChannelHandlerContext ctx) {
//        if (!cmdProService.isEffectiveDevice(idCode)) {
//            System.out.println("#照明状态上传请求-未注册设备 idCode=" + idCode);
//            return;
//        }
//        String answerText = "hm+67+0+4+end";
//        log.info(">>照明状态上传请求-应答数据>>" + answerText);
//        answerCmd(answerText, ctx);
//        producer.sendZhaoMingStatus(askText);
//    }
//
//    private void uploadDaoLiuBanStatus(String askText, String idCode, ChannelHandlerContext ctx) {
//        if (!cmdProService.isEffectiveDevice(idCode)) {
//            System.out.println("#导流板状态上传请求-未注册设备 idCode=" + idCode);
//            return;
//        }
//        String answerText = "hm+66+0+4+end";
//        log.info(">>导流板状态上传请求-应答数据>>" + answerText);
//        answerCmd(answerText, ctx);
//        producer.sendDaoLiuStatus(askText);
//    }
//
//    private void uploadXiaoChuangStatus(String askText, String idCode, ChannelHandlerContext ctx) {
//        if (!cmdProService.isEffectiveDevice(idCode)) {
//            System.out.println("#小窗状态上传请求-未注册设备 idCode=" + idCode);
//            return;
//        }
//        String answerText = "hm+65+0+4+end";
//        log.info(">>小窗状态上传请求-应答数据>>" + answerText);
//        answerCmd(answerText, ctx);
//        //发送湿度请求到消息队列
//        producer.sendXiaoChuangStatus(askText);
//    }
//
//    private void uploadJiaReQiStatus(String askText, String idCode, ChannelHandlerContext ctx) {
//        if (!cmdProService.isEffectiveDevice(idCode)) {
//            System.out.println("#加热状态上传请求-未注册设备 idCode=" + idCode);
//            return;
//        }
//        String answerText = "hm+64+0+4+end";
//        log.info(">>加热温度上传请求-应答数据>>" + answerText);
//        answerCmd(answerText, ctx);
//        //发送湿度请求到消息队列
//        producer.sendJiaReStatus(askText);
//    }
//
//    private void uploadDianBiao(String[] dataArray, String askText, String idCode, ChannelHandlerContext ctx) {
//        if (!cmdProService.isEffectiveDevice(idCode)) {
//            System.out.println("#电表上传请求-未注册设备 idCode=" + idCode);
//            return;
//        }
//        String answerText = "hm+32+0+4+end";
//        log.info(">>电表上传请求-应答数据>>" + answerText);
//        answerCmd(answerText, ctx);
//        //发送湿度请求到消息队列
//        producer.sendDianBiaoData(askText);
//    }
//
//    private void uploadShuiBiao(String[] dataArray, String askText, String idCode, ChannelHandlerContext ctx) {
//        if (!cmdProService.isEffectiveDevice(idCode)) {
//            System.out.println("#水表上传请求-未注册设备 idCode=" + idCode);
//            return;
//        }
//        String answerText = "hm+31+0+4+end";
//        log.info(">>水表温度上传请求-应答数据>>" + answerText);
//        answerCmd(answerText, ctx);
//        //发送湿度请求到消息队列
//        producer.sendShuiBiaoData(askText);
//    }
//    private void uploadWeiZhiTemp(String askText, String idCode, ChannelHandlerContext ctx) {
//        if (!cmdProService.isEffectiveDevice(idCode)) {
//            System.out.println("##位置温度上传请求-未注册设备 idCode=" + idCode);
//            return;
//        }
//        String answerText = "hm+9+0+4+end";
//        log.info(">>位置温度上传请求-应答数据>>" + answerText);
//        answerCmd(answerText, ctx);
//        //发送湿度请求到消息队列
//        producer.sendWeiZhi(askText);
//    }
//
//    private void uploadShuiNuanTemp(String askText, String idCode, ChannelHandlerContext ctx) {
//
//        if (!cmdProService.isEffectiveDevice(idCode)) {
//            System.out.println("##水暖上传请求-未注册设备 idCode=" + idCode);
//            return;
//        }
//        String answerText = "hm+8+0+4+end";
//        log.info(">>水暖上传请求-应答数据>>" + answerText);
//        answerCmd(answerText, ctx);
//        //发送湿度请求到消息队列
//        producer.sendShuiNuan(askText);
//    }
//
//    private void uploadStatusWaraning(String askText, String idCode, ChannelHandlerContext ctx) {
//        if (!cmdProService.isEffectiveDevice(idCode)) {
//            System.out.println("##状态报警上传请求-未注册设备 idCode=" + idCode);
//            return;
//        }
//        String answerText = "hm+42+0+2+end";
//        log.info(">>状态报警上传请求-应答数据>>" + answerText);
//        answerCmd(answerText, ctx);
//        //发送湿度请求到消息队列
//        producer.sendWarning(askText);
//    }
//
//    private void uploadYaLi(String[] dataArray, String askText, String idCode, ChannelHandlerContext ctx) {
//        if (!cmdProService.isEffectiveDevice(idCode)) {
//            System.out.println("##压力 上传请求-未注册设备 idCode=" + idCode);
//            return;
//        }
//        String answerText = "hm+24+0+8+end";
//        log.info(">>压力  等级上传请求-应答数据>>" + answerText);
//        answerCmd(answerText, ctx);
//        //发送湿度请求到消息队列
//        producer.sendYaLi(askText);
//    }
//
//    private void uploadCo2(String[] dataArray, String askText, String idCode, ChannelHandlerContext ctx) {
//        if (!cmdProService.isEffectiveDevice(idCode)) {
//            System.out.println("##CO2 上传请求-未注册设备 idCode=" + idCode);
//            return;
//        }
//        //TODO
//        String answerText = "hm+23+0+8+end";

//    //拆分粘包数据
    public JSONArray parseAskCmdPackage(String text) {
        String key = "end";
        Pattern pattern = Pattern.compile(key);
        Matcher matcher = pattern.matcher(text);
        int count = 0;
        while (matcher.find()) {
            count++;
        }
        JSONArray dataJa = new JSONArray();
        if (count == 1) {
            dataJa.add(text);
        } else {
            for (int a = 0; a < count; a++) {
                int p1 = text.indexOf("end");
                dataJa.add(text.substring(0, p1 + 3));
                text = text.substring(p1 + 3, text.length());
            }
        }
        return dataJa;
    }
}
